summaryrefslogtreecommitdiffstats
path: root/target/linux/ramips/base-files
diff options
context:
space:
mode:
authorGabor Juhos <juhosg@openwrt.org>2011-07-03 15:02:01 +0000
committerGabor Juhos <juhosg@openwrt.org>2011-07-03 15:02:01 +0000
commitc8010517d5c662116d0a33c610634e5a1e487338 (patch)
tree136e1b5351fc7ca39b65422a8d9d30c8c2a230b3 /target/linux/ramips/base-files
parent3334d0604e9c162d5f0db7ca7270b8a6d75f6528 (diff)
downloadmaster-31e0f0ae-c8010517d5c662116d0a33c610634e5a1e487338.tar.gz
master-31e0f0ae-c8010517d5c662116d0a33c610634e5a1e487338.tar.bz2
master-31e0f0ae-c8010517d5c662116d0a33c610634e5a1e487338.zip
ramips: add hotplug script to extract eeprom for the rt2x00 driver
SVN-Revision: 27393
Diffstat (limited to 'target/linux/ramips/base-files')
-rw-r--r--target/linux/ramips/base-files/etc/hotplug.d/firmware/10-rt2x00-eeprom55
1 files changed, 55 insertions, 0 deletions
diff --git a/target/linux/ramips/base-files/etc/hotplug.d/firmware/10-rt2x00-eeprom b/target/linux/ramips/base-files/etc/hotplug.d/firmware/10-rt2x00-eeprom
new file mode 100644
index 0000000000..398ad79ecf
--- /dev/null
+++ b/target/linux/ramips/base-files/etc/hotplug.d/firmware/10-rt2x00-eeprom
@@ -0,0 +1,55 @@
+#!/bin/sh
+
+rt2x00_eeprom_die() {
+ echo "rt2x00 eeprom: " "$*"
+ exit 1
+}
+
+rt2x00_eeprom_extract() {
+ local part=$1
+ local offset=$2
+ local count=$3
+ local mtd
+
+ . /etc/functions.sh
+
+ mtd=$(find_mtd_part $part)
+ [ -n "$mtd" ] || \
+ rt2x00_eeprom_die "no mtd device found for partition $part"
+
+ dd if=$mtd of=/lib/firmware/$FIRMWARE bs=1 skip=$offset count=$count || \
+ rt2x00_eeprom_die "failed to extract from $mtd"
+}
+
+[ -e /lib/firmware/$FIRMWARE ] && exit 0
+
+case "$FIRMWARE" in
+"RT288X.eeprom" | \
+"RT305X.eeprom")
+ . /lib/ramips.sh
+
+ local board=$(ramips_board_name)
+
+ case $board in
+ dir-300-b1)
+ rt2x00_eeprom_extract "devdata" 16384 272
+ ;;
+
+ f5d8235v2 | \
+ fonera20n | \
+ hw550-3g | \
+ mofi3500-3gn | \
+ pwh2004 | \
+ rt-n15 | \
+ v22rw-2x2 | \
+ wcr150gn | \
+ whr-g300n)
+ rt2x00_eeprom_extract "factory" 0 272
+ ;;
+
+ *)
+ rt2x00_eeprom_die "board $board is not supported yet"
+ ;;
+ esac
+ ;;
+esac \ No newline at end of file